// IMKit-Anthy: A Qtopia InputMethod interface for Anthy
// Copyright (C) 2002  YamaKen <yamaken@bp.iij4u.or.jp>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

// $Name: IMKIT_0_4_0 $
// $Id: ui_anthy.h,v 1.3 2002/08/29 14:00:14 yamaken Exp $

//TODO: Obsolete this. Replace with generic keyfilter
//configuration mechanism.

#ifndef IMKIT_UI_ANTHY_H
#define IMKIT_UI_ANTHY_H

#include "ui.h"
#include "ui_std.h"
#include "engine_anthy.h"
#include "imwidget_std.h"


class CandidateWindow;

class AnthyGUI : public StdIMUserInterface {
  Q_OBJECT

protected:
  QCharKeyMapper<> *cand_win_keymapper;
  GraphCharMapper<> *graph_keymapper;
  QCharKeyMapper<> *global_ctrl_keymapper, *editing_context_ctrl_keymapper;
  OneShotKeyMapper<> *ctrl_x_mapper;
  ButtonMapper<> *cand_win_btnmapper;
  ButtonMapper<> *global_btnmapper, *editing_context_btnmapper;

protected:
  virtual CascadeKeyFilter *create_keyfilter(void);
  virtual void set_activity(bool activity);

protected slots:
  virtual void update_preedit_state(PreeditState new_state);

public:
  AnthyGUI(AnthyEngine *engine_init,
           StdIMWidgetFactory *imwidget_factory_init);
  virtual bool is_active(void) const;
};

#endif  //IMKIT_UI_ANTHY_H
